/*
 *  (c) Copyright Hewlett-Packard Company 2001 
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: RuntimeRDFException.java,v 1.2 2001/07/04 17:54:04 bwm Exp $
 *
 */

package com.hp.hpl.mesa.rdf.jena.common.prettywriter;


import com.hp.hpl.mesa.rdf.jena.model.RDFException;

/**
 * Wraps RDFExceptions so we can pass them through the java.util.Iterator
 * interfaces. The idea is that when these are used they should always be
 * caught and have the underlying exception rethrown.
 * @author jjc
 * @version  Release='$Name:  $' Revision='$Revision: 1.2 $' Date='$Date: 2001/07/04 17:54:04 $'
 */
class RuntimeRDFException extends RuntimeException {
  private RDFException rdfEx;
  public RuntimeRDFException(RDFException e) {
    rdfEx = e;
  }
  RDFException getUnderlyingException() {
    return rdfEx;
  }
}