/*
 * ResourceReader.java
 *
 * Created on June 29, 2001, 9:54 PM
 */

package com.hp.hpl.mesa.rdf.jena.common.regression;
import java.io.InputStreamReader;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.IOException;
/**
 * read a data file stored on the class path.
 * To use this, ensure your data is on the class path (e.g. in the
 * program jar, or in a separate data.jar), and give a relative path
 * name to the data.
 * Not intended for an applet environment.
 * 
 * @author  jjc
 * @version  Release='$Name:  $' Revision='$Revision: 1.3 $' Date='$Date: 2001/07/04 18:40:34 $'
 */
public class ResourceReader extends InputStreamReader {
    // If false use FileInputSDtream's assuming we are in the correct directory;
    static boolean useClassLoader = false;
    /** Creates new ResourceReader 
     * @param resource The filename of the data file relative to the Java classpath.
     * @exception java.lang.SecurityException If cannot access the classloader, e.g. in applet.
     * @exception java.lang.IllegalArgumentException If file not found.
     */
    public ResourceReader(String resource) throws IOException {
        super(getInputStream(resource));
    }
    
    static private InputStream getInputStream(String prop) throws IOException {
        if ( useClassLoader) {
            ClassLoader loader = ResourceReader.class.getClassLoader();
            if ( loader == null ) 
                throw new SecurityException("Cannot access class loader");
            InputStream in = loader.getResourceAsStream(prop);
            if ( in == null )
                throw new IllegalArgumentException("Resource: " + prop + " not found on class path.");
            return in;
        } else {
            return new FileInputStream(prop);
        }
    }

}
