/* -*-Java-*-
*******************************************************************
*
* File:         DriverInterbaseHash.java
* RCS:          $Header: /cvsroot/jena/jena/src/com/hp/hpl/mesa/rdf/jena/rdb/DriverInterbaseHash.java,v 1.4 2001/12/05 17:56:50 der Exp $
* Author:       Dave Reynolds, HPLabs, Bristol
* Created:      30/10/01
* Modified:     $Date: 2001/12/05 17:56:50 $
* Status:       Experimental (Do Not Distribute)
*
* (c) Copyright 2001, Hewlett-Packard Company, all rights reserved.
* [See end of file]
*********************************************************************/

//=======================================================================
// Package
package com.hp.hpl.mesa.rdf.jena.rdb;

//=======================================================================
// Imports
import com.hp.hpl.mesa.rdf.jena.common.*;
import com.hp.hpl.mesa.rdf.jena.model.*;
import java.io.*;
import java.sql.*;
import java.util.*;
import com.hp.hpl.jena.util.Log;

//=======================================================================
/**
* Adaption of the base generic layout driver to the limitations of
* InterBase SQL.  The only substantial adaptation is done in the SQL
* file, the java class is just boilerplate.
*
* @author <a href="mailto:der@hplb.hpl.hp.com">Dave Reynolds</a>
* @version $Revision: 1.4 $ on $Date: 2001/12/05 17:56:50 $
*/

public class DriverInterbaseHash extends DriverGenericHash implements IRDBDriver {

    /**
     * Create a bare instance of the driver. It is not functional until a
     * database connection has been supplied via setConnection.
     */
    public DriverInterbaseHash() throws RDFRDBException {
        super();
        // Set configuration parameters
        DRIVER_NAME = "interbase.interclient.Driver";
        DATABASE_TYPE = "Interbase";
        //SQL_FILE = "etc/interbase_hash.sql";
        SQL_FILE = "etc/interbase_all.sql";
        ID_SQL_TYPE = "CHAR(16)";
        MAX_LITERAL = 250;
        //loadDatabaseDriver();
    }

    /**
     * Override the generic unique hash function to avoid the base64 overhead
     * since the Interbase jdbc implementation handles full 8bit chars.
     */
    protected synchronized IDBID uniqueHash(String arg) {
        m_hashGenerator.update(arg.getBytes());
        byte[] res = m_hashGenerator.digest();
        m_hashGenerator.reset();
        return new DBIDHash(res);
    }

}

/*
 *  (c) Copyright Hewlett-Packard Company 2000, 2001
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
