/*
 *  (c) Copyright Hewlett-Packard Company 2000 
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Hpps.java
 *
 * Created on 28 July 2000, 18:19
 */

package com.hp.hpl.mesa.rdf.jena.sample;

import com.hp.hpl.mesa.rdf.jena.common.*;
import com.hp.hpl.mesa.rdf.jena.model.*;

/**
 *
 * @author  bwm
 * @version Release='$Name:  $' Revision='$Revision: 1.1 $' Date='$Date: 2001/01/05 14:17:41 $'
 */
public class H {
    
    // next available error code = 2
    
    protected static final String URI = "http://aldabaran.hpl.hp.com/hpps/";
    
    public static String getURI()
    {
        return URI;
    }
    
    protected static final String   nabout      = "about";
    public    static       Property about       = null;
    
    protected static final String   nPerson     = "Person";
    public    static       Resource Person      = null;
    
    protected static final String   nRating     = "Rating";
    public    static       Resource Rating      = null;
    
    protected static final String   nratings    = "ratings";
    public    static       Property ratings     = null;
    
    static {
        try {
            about = new PropertyImpl(URI, nabout);
            Person = new ResourceImpl(URI+nPerson);
            Rating = new ResourceImpl(URI+nRating);
            ratings = new PropertyImpl(URI, nratings);
        } catch (Exception e) {
            ErrorHelper.logInternalError("Hpps", 1, e);
        }
    }
}